/*
 * Copyright 2015 - 2022 gary@drinkingtea.net
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */

#undef NDEBUG

#include <map>
#include <ox/model/model.hpp>
#include <ox/std/std.hpp>

std::map<ox::String, ox::Error(*)()> tests = {
	{
		{
			"ModelValue",
			[] {
				ox::ModelValue v;
				oxReturnError(v.setType<int32_t>());
				//v.m_type = ox::ModelValue::getType<int32_t>();
				if (v.type() != ox::ModelValue::Type::SignedInteger32) {
					return OxError(1, "type is wrong");
				}
				oxReturnError(v.set<int32_t>(5));
				return ox::Error{};
			}
		},
	}
};

int main(int argc, const char **args) {
	if (argc > 0) {
		auto testName = args[1];
		if (tests.find(testName) != tests.end()) {
			oxAssert(tests[testName](), "Test failed...");
		}
	}
	return 0;
}
